angular.module('omega').filter 'profiles', (builtinProfiles, profileOrder) ->
  charCodePlus = '+'.charCodeAt(0)
  charCodeUnderscore = '_'.charCodeAt(0)
  builtinProfileList = (profile for _, profile of builtinProfiles)
  (options, filter) ->
    result = []
    for name, value of options when name.charCodeAt(0) == charCodePlus
      result.push value
    if (typeof filter == 'object' or (
      typeof filter == 'string' and filter.charCodeAt(0) == charCodePlus))
      if typeof filter == 'string'
        filter = filter.substr(1)
      result = OmegaPac.Profiles.validResultProfilesFor(filter, options)
    if filter == 'all'
      result = result.filter (profile) ->
        # Hide profiles beginning with underscore.
        profile.name.charCodeAt(0) != charCodeUnderscore
      result = result.concat builtinProfileList
    else
      result = result.filter (profile) ->
        # Hide profiles beginning with double underscore in options.
        (profile.name.charCodeAt(0) != charCodeUnderscore or
        profile.name.charCodeAt(1) != charCodeUnderscore)
    if filter == 'sorted'
      result.sort profileOrder
    result

angular.module('omega').filter 'tr', (omegaTarget) -> omegaTarget.getMessage
angular.module('omega').filter 'dispName', (omegaTarget) ->
  (name) -> omegaTarget.getMessage('profile_' + name) || name
